package com.kmall.admin.service.impl;

import com.kmall.admin.dao.BrandDao;
import com.kmall.admin.dao.GoodsDao;
import com.kmall.admin.entity.BrandEntity;
import com.kmall.admin.entity.GoodsEntity;
import com.kmall.admin.service.BrandService;
import com.kmall.common.utils.RRException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Service实现类
 *
 * @author Scott
 * @email
 * @date 2017-08-19 17:59:15
 */
@Service("brandService")
public class BrandServiceImpl implements BrandService {
    @Autowired
    private BrandDao brandDao;
    @Autowired
    private GoodsDao goodsDao;

    @Override
    public BrandEntity queryObject(Integer id) {
        return brandDao.queryObject(id);
    }

    @Override
    public List<BrandEntity> queryList(Map<String, Object> map) {
        return brandDao.queryList(map);
    }

    @Override
    public int queryTotal(Map<String, Object> map) {
        return brandDao.queryTotal(map);
    }

    @Override
    public int save(BrandEntity brand) {
        return brandDao.save(brand);
    }

    @Override
    public int update(BrandEntity brand) {
        return brandDao.update(brand);
    }

    @Override
    public int delete(Integer id) {
        return brandDao.delete(id);
    }

    @Override
    public int deleteBatch(Integer[] ids) {
        for (Integer id : ids) {
            BrandEntity brand = queryObject(id);

            Map<String, Object> map = new HashMap<>();
            map.put("brandId", id);
            List<GoodsEntity> goodsList = goodsDao.queryList(map);

            if (goodsList != null && goodsList.size() > 0) {
                throw new RRException("品牌【" + brand.getName() + "】下还存在【" + goodsList.size() + "】个商品，删除失败！");
            }
            delete(id);
        }

        return 1;
    }
}
